package com.landray.kmss.sys.attachment.util;

import com.landray.kmss.util.MD5Util;
import com.landray.kmss.sys.config.util.LicenseUtil;
import com.landray.kmss.util.StringUtil;
import java.net.URLDecoder;
import java.net.URLEncoder;
import com.landray.kmss.util.DESEncrypt;

public final class SysAttCryptUtil
{
    private static final String securityKey = "kmssAttachmentKey";
    private static String licenseKey;
    
    static {
        SysAttCryptUtil.licenseKey = null;
    }
    
    public static String encrypt(final String fileInfo) throws Exception {
        final DESEncrypt dESEncrypt = new DESEncrypt("kmssAttachmentKey");
        final String encodeStr = dESEncrypt.encryptString(fileInfo);
        return URLEncoder.encode(encodeStr, "UTF-8");
    }
    
    public static String decrypt(String encryptKey) throws Exception {
        final DESEncrypt dESEncrypt = new DESEncrypt("kmssAttachmentKey");
        encryptKey = URLDecoder.decode(encryptKey, "UTF-8");
        encryptKey = encryptKey.replace(' ', '+');
        return dESEncrypt.decryptString(encryptKey);
    }
    
    private static String getLicenseKey() {
        if (StringUtil.isNotNull(SysAttCryptUtil.licenseKey)) {
            return SysAttCryptUtil.licenseKey;
        }
        return SysAttCryptUtil.licenseKey = (StringUtil.isNull(LicenseUtil.get("license-customer-id")) ? "kmssAttachmentKey" : MD5Util.getMD5String(String.valueOf(LicenseUtil.get("license-customer-id"))));
    }
    
    public static String encryptByLicenseId(final String fileInfo) throws Exception {
        final DESEncrypt dESEncrypt = new DESEncrypt(getLicenseKey());
        final String encodeStr = dESEncrypt.encryptString(fileInfo);
        return URLEncoder.encode(encodeStr, "UTF-8");
    }
    
    public static String decryptByLicenseId(String encryptKey) throws Exception {
        final DESEncrypt dESEncrypt = new DESEncrypt(getLicenseKey());
        encryptKey = URLDecoder.decode(encryptKey, "UTF-8");
        encryptKey = encryptKey.replace(' ', '+');
        return dESEncrypt.decryptString(encryptKey);
    }
}
